using Bp.Sync.BackEnd.Infrastructure.Repositories.FcBusinesses;
using Bp.Sync.Domain.Entities.FcBusinesses;
using Bp.Sync.Dto.Results;
using CommonLibrary;
using Dapper;
using EasyNetQ;
using Microsoft.Extensions.Configuration;
using System;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Vina.Search.Infrastructure.Mappings;

namespace Bp.Sync.BackEnd.Application.Commands.FcBusinesses.OutboundStatistics
{
    public class SyncOutboundStatisticHandler : MediatR.IRequestHandler<SyncOutboundStatisticCommand, BaseResult>
    {
        private readonly IDbConnection _dbConnection;
        private readonly IOutboundStatisticRepository _OutboundStatisticRepository;
        private readonly IBus _bus;

        public SyncOutboundStatisticHandler(IConfiguration configuration, IOutboundStatisticRepository OutboundStatisticRepository, IBus bus)
        {
            var connectionString = configuration.GetConnectionString("FcBusinessConnection");
            _dbConnection = new SqlConnection(connectionString);
            _OutboundStatisticRepository = OutboundStatisticRepository;
            _bus = bus;
        }

        public async Task<BaseResult> Handle(SyncOutboundStatisticCommand request, CancellationToken cancellationToken)
        {
            var rs = new BaseResult();

            if (request.Ids.Count() > 1000)
            {
                var length = request.Ids.Count();
                if (length > 0)
                {
                    for (int i = 0; i <= length / 1000; i++)
                    {
                        if (length > i * 1000)
                        {
                            var ids = request.Ids.Skip(i * 1000).Take(1000).ToList();
                            if (ids.Count() > 0)
                            {
                                await _bus.SendAsync($"SyncToElasticOutboundStatistic", ids.ConvertListLongToString());
                            }
                        }
                    }
                }
                return new BaseResult { Result = Result.Success, Message = $"sent {length} OutboundStatistics" };
            }
            if (!request.Ids.Any())
            {
                rs.Message = $"no data to update";
                rs.Result = Dto.Results.Result.Success;
                return rs;
            }

            try
            {
                var p = new Dto.DapperTypes.IdsParam(request.Ids);
                var OutboundStatistics = await _dbConnection.QueryAsync<OutboundStatistic>("Sync_OutboundStatistic_Get_By_List_Id", p, commandType: CommandType.StoredProcedure);
                if (OutboundStatistics.Any())
                {
                    var outbounds = OutboundStatistics.ToOutboundStatistics();

                    var billids = outbounds.Select(x => x.BillId).Distinct().ToList();
                    var p2 = new Dto.DapperTypes.IdsParam(billids);
                    var bills = await _dbConnection.QueryAsync<Domain.Entities.FcBusinesses.Bills.OutboundBill>("Sync_OutboundBill_Get_By_List_Id", p2, commandType: CommandType.StoredProcedure);

                    foreach (var item in outbounds)
                    {
                        var bill = bills.FirstOrDefault(x => x.Id == item.BillId);
                        item.BillIsDeleted = bill?.IsDeleted;
                        item.BillStatus = bill?.BillStatus;
                        item.BillType = bill?.BillType;
                        item.BillCreatedTime = bill?.CreatedTime;
                        item.BillOriginBranchId = bill?.OriginBranchId;
                        item.BillDestinationBranchId = bill?.DestinationBranchId;
                        item.BillPartnerId = bill?.PartnerId;

                        if (item.OutboundBaseUnitQuantity > 0 && item.OutboundQuantity > 0)
                        {
                            item.OutboundBaseUnitCost = item.OutboundCost * item.OutboundQuantity / item.OutboundBaseUnitQuantity;
                            item.OutboundBaseUnitPrice = item.OutboundPrice * item.OutboundQuantity / item.OutboundBaseUnitQuantity;
                        }
                    }

                    var rs2 = await _OutboundStatisticRepository.AddManyAsync(outbounds);
                    if (rs2.Result == Result.Success)
                    {
                        await _dbConnection.ExecuteAsync("Synced_OutboundStatistic_By_List_Id", p, commandType: CommandType.StoredProcedure);
                        rs.Message = $"{outbounds.Count()} synced";
                        rs.Result = Result.Success;
                        await _bus.SendAsync($"SyncToElasticFcProductOutbound", request.Ids.ConvertListLongToString());
                    }
                    else
                    {
                        rs.Message = $"can not insert db";
                        rs.Result = Result.Success;
                    }
                }
                else
                {
                    rs.Message = $"no data to update";
                    rs.Result = Result.Success;
                }
            }
            catch (Exception ex)
            {
                rs.Message = ex.Message.ToString();
                rs.Result = Result.SystemError;
            }
            return rs;
        }
    }
}